// QWERTYKeypad.h : header file
//

#if !defined(AFX_QWERTYKEYPAD_H__3980AE32_BE62_11D1_A701_00A0C919EFA5__INCLUDED_)
#define AFX_QWERTYKEYPAD_H__3980AE32_BE62_11D1_A701_00A0C919EFA5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Resource.h"

//////////////////////////////////////////////////////////////////////////////
//
//This dialog is used as a generic QWERTY keypad.  This was taken from the
//DMX software.  CE2.11 has a built in SIP and so this may no longer be necessary.
//The DMX version of this used string manipulation to respond to button pushes.
//It has been modified in NextGen to use keyboard events.  This makes it behave
//more like a standard edit control.  Requires the keyboard driver to be present in
//the kernal.  The Engine DLL exports a global C function that creates this
//dialog and manages returning the updated string.

/////////////////////////////////////////////////////////////////////////////
// CQWERTYKeypad dialog

class CQWERTYKeypad : public TDialog
{
   // Construction
   public:
   CQWERTYKeypad(CString& RRemoteString, int MaxChars, CString Type, 
         CString Caption=_T(""), CWnd* pParent = NULL);   // standard constructor

   // Dialog Data
   //{{AFX_DATA(CQWERTYKeypad)
	enum { IDD = IDD_QWERTYKeypad };
	CButton	m_chkShift;
   CButton m_CapsLockCtl;
   CString m_DataWindowString;
   BOOL    m_CapsLock;
	BOOL	m_fShift;
	//}}AFX_DATA
   
   CEdit* m_pDataWindowCtl;

   // Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(CQWERTYKeypad)
   protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL

   // Implementation

   // Generated message map functions
   //{{AFX_MSG(CQWERTYKeypad)
   afx_msg void OnAButton();
   afx_msg void OnBButton();
   afx_msg void OnBackspaceButton();
   afx_msg void OnCButton();
   afx_msg void OnCapsLock();
   afx_msg void OnClearButton();
   afx_msg void OnCommaButton();
   afx_msg void OnDButton();
   afx_msg void OnEButton();
   afx_msg void OnEightButton();
   afx_msg void OnEndButton();
   afx_msg void OnFButton();
   afx_msg void OnFiveButton();
   afx_msg void OnFourButton();
   afx_msg void OnGButton();
   afx_msg void OnHButton();
   afx_msg void OnHomeButton();
   afx_msg void OnIButton();
   afx_msg void OnJButton();
   afx_msg void OnKButton();
   afx_msg void OnLButton();
   afx_msg void OnLeftButton();
   afx_msg void OnMButton();
   afx_msg void OnMinusBtn();
   afx_msg void OnNButton();
   afx_msg void OnNineButton();
   afx_msg void OnOButton();
   afx_msg void OnOneButton();
   afx_msg void OnPButton();
   afx_msg void OnPeriodButton();
   afx_msg void OnQButton();
   afx_msg void OnRButton();
   afx_msg void OnRightButton();
   afx_msg void OnSButton();
   afx_msg void OnSevenButton();
   afx_msg void OnSixButton();
   afx_msg void OnSlashBtn();
   afx_msg void OnSpaceButton();
   afx_msg void OnTButton();
   afx_msg void OnThreeButton();
   afx_msg void OnTwoButton();
   afx_msg void OnUButton();
   afx_msg void OnVButton();
   afx_msg void OnWButton();
   afx_msg void OnXButton();
   afx_msg void OnYButton();
   afx_msg void OnZButton();
   afx_msg void OnZeroButton();
   virtual BOOL OnInitDialog();
   virtual void OnOK();
   afx_msg void OnBackslashButton();
   virtual void OnCancel();
   afx_msg void OnClrButton();
   afx_msg void OnEqualBtn();
   afx_msg void OnLeftBracketButton();
   afx_msg void OnRightBracketButton();
   afx_msg void OnSemiColonButton();
   afx_msg void OnQuoteButton();
   afx_msg void OnDegreeButton();
   afx_msg void OnShiftButton();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()

   // Methods
   void UpdateCase();
   void Shift(bool bInvert = false);
   void UnShift(bool bInvert = false);
      
   // Attributes
   protected:
   CString     KeypadBuffer;     // This is our 80 character buffer for input
   CString&    RemoteString;     // Remote string we are entering data into
   int         MaxChars;         // Maximum number of characters in string returned
   CString     Type;             // Field which can be used for string type verification
   CFont       Tahoma14;         // Tahoma14 font that we will create
   CFont*      pCurrentFont;     // Pointer to the CEdit font prior to the change
   CString     WindowCaption;
   bool        m_bDefault;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QWERTYKEYPAD_H__3980AE32_BE62_11D1_A701_00A0C919EFA5__INCLUDED_)
